// Common.cpp : Defines the entry point for the DLL application.
// Update : 31.12.2002 (MrAndrew)
#include "stdafx.h"

#define COMMON_API __declspec(dllexport)
#include "cmninfo.h"
#include "cmnlog.h"
#include "cmnzip.h"
#include "CmnMisc.h"
#include "CmnStg.h"

DWORD cmnInitLibrary();	// setup the library
DWORD cmnFreeLibrary();

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    float f = 1.0f;	// This must be here, otherwise the error with floating point not loaded would occur

	switch(ul_reason_for_call) {
		case DLL_PROCESS_ATTACH :
			DBGTRACE(_T("* The Common.dll is attaching\n"));
			try {
				cmnInitLibrary();	// Init the directories variables
				/* locate zip.dll */
				if(ERROR_MOD_NOT_FOUND == InitZipLib()) {
					TRACE(_T("Library Zip.dll has not been found. Zip support won't be available."));
				}
				/* set default setup.ini file and ANSI format */
				cmnSetIniFileName(_S_SETUP_INI);
			}
			catch(XException exp) {
				exp.trace();
			}
			break;
		case DLL_PROCESS_DETACH :
			DBGTRACE(_T("* The Common.dll is detaching\n"));
			cmnFreeLibrary();
			break;
		default :
			g_sLogSettings.bLogToFile = TRUE;
			break;
	}
	return TRUE;
}


DWORD cmnInitLibrary()
{
	#pragma COMMENT("Can be optimalized to use only one char buffer!!!")
	char BufferA[MAX_PATH + 1];
	wchar_t BufferW[MAX_PATH + 1];

    DWORD dwRealSize = 0;

	dwRealSize = ::GetSystemDirectoryA(BufferA, MAX_PATH + 1);

	if(dwRealSize++)	// +1 for the terminating zero char
	{
		g_lpszSysDir = new char[dwRealSize];
		
		if(g_lpszSysDir)
		{
			strcpy(g_lpszSysDir, BufferA);
		}
	}

	dwRealSize = 0;

	dwRealSize = ::GetSystemDirectoryW(BufferW, MAX_PATH + 1);

	if(dwRealSize++)	// +1 for the terminating zero char
	{
		g_lpwszSysDir = new wchar_t[dwRealSize];
		
		if(g_lpwszSysDir)
		{
			wcscpy(g_lpwszSysDir, BufferW);
		}
	}

	dwRealSize = 0;

	dwRealSize = ::GetWindowsDirectoryA(BufferA, MAX_PATH + 1);

	if(dwRealSize++)	// +1 for the terminating zero char
	{
		g_lpszWinDir = new char[dwRealSize];
		
		if(g_lpszWinDir)
		{
			strcpy(g_lpszWinDir, BufferA);
		}
	}

	dwRealSize = 0;

	dwRealSize = ::GetWindowsDirectoryW(BufferW, MAX_PATH + 1);

	if(dwRealSize++)	// +1 for the terminating zero char
	{
		g_lpwszWinDir = new wchar_t[dwRealSize];
		
		if(g_lpwszWinDir)
		{
			wcscpy(g_lpwszWinDir, BufferW);
		}
	}
	//
	// Init table for CRC computing
	Init_CRC32Table();
	
	return ERROR_SUCCESS;
}

DWORD cmnFreeLibrary()
{
	// Free the paths
	if(g_lpszSysDir) { delete g_lpszSysDir; }
	if(g_lpszWinDir) { delete g_lpszWinDir;	}
	if(g_lpwszSysDir) { delete g_lpwszSysDir;	}
	if(g_lpwszWinDir) { delete g_lpwszWinDir;	}

	return ERROR_SUCCESS;
}

