/*
 *
 * Common.h - dll include file - include this to get access to all exported functions
 * Date:	23.12.2002
 * Update:	-
 * Author:	Ondrej Burisin & Jiri Formanek
 *
 */

#ifndef _COMMON_H_
  #define _COMMON_H_  

	/*
	Error 4290:
	A function is declared using exception specification, which Visual C++ accepts 
	but does not implement. Code with exception specifications that are ignored 
	during compilation may need to be recompiled and linked to be reused in 
	future versions supporting exception specifications.
	*/
	#pragma warning( disable : 4290 )

  
  // If it is not defined, we define it as a import
  // Import exported func to external module
  #ifndef COMMON_API
    #define COMMON_API __declspec(dllimport)
  #endif

  #include "Symbols.h"	// Some macros
  #include "Strings.h"	// Strings defined as symbolic constants
  #include <exception>  // standard C++ exception

  #include "CmnError.h"	// Common.DLL defined error codes  
  #include "CmnLog.h"	// Diagnostic  - TRACE
  #include "CmnFile.h"	// The file reading functions
  #include "CmnStg.h"	// Storage - IStream, IStorage
  #include "CmnStr.h"   // String functions
  #include "CmnInfo.h"	// Information about windows, system ...
  #include "CmnMisc.h"	// Misc functions ...
  #include "CmnZip.h"	// Compress and decompress functions
  #include "CmnNet.h"	// Network TCP/IP support
  #include "CmnMan.h"

#endif // _COMMON_H_