#include "StdAfx.h"

#define		DISPLAY_API	__declspec(dllexport)

#include "../Common/Common.h"

#include "xindexbuffer.h"

XIndexBuffer::XIndexBuffer(void)
{
	m_lpDevice = NULL;
	m_pIndexBuffer = NULL;
}

XIndexBuffer::~XIndexBuffer(void)
{
	Release();
	m_lpDevice = NULL;
}

int		XIndexBuffer::Create(UINT uiLength, DWORD dwUsage, D3DFORMAT dwFormat, D3DPOOL dwPool, LPDIRECT3DDEVICE8	lpDevice)
{	
	if(!lpDevice) 
	{
		XException exp("CreateIndexBuffer: Device is invalid.");
		THROW(exp);			
	}
	if(!m_pIndexBuffer) 
	{
		m_lpDevice = lpDevice;
		m_uiLength = uiLength;
		m_dwUsage = dwUsage;
		m_dwFormat = dwFormat;
		m_dwPool = dwPool;

		DWORD dwRet = m_lpDevice->CreateIndexBuffer(uiLength, dwUsage, dwFormat, dwPool, &m_pIndexBuffer);
		if(dwRet != S_OK) {
			XException exp("Cannot create index buffer.", dwRet);
			THROW(exp);				
		}
		return 0;
	}
	return -1;
}

int			XIndexBuffer::Restore()
{
	if(m_lpDevice && !m_pIndexBuffer)
	{
		DWORD dwRet = m_lpDevice->CreateIndexBuffer(m_uiLength, m_dwUsage, m_dwFormat, m_dwPool, &m_pIndexBuffer);
		if(dwRet != S_OK) {
			XException exp("Cannot create index buffer.", dwRet);
			THROW(exp);	
		}
		return 0;
	}
	return -1;
}

void		XIndexBuffer::Release()
{
	SAFE_RELEASE(m_pIndexBuffer);
}
