#pragma once
class XResourceManager;
enum MESHTYPE	{BOX, CYLINDER, SPHERE, TEAPOT, TORUS, CUSTOM };

class DISPLAY_API XMesh
{
	LPD3DXMESH				m_lpMesh;
	BOOL					m_bVisible;
	D3DXMATRIX				*m_lpTransMat;

	// information for restoring
	char					m_szFilePath[MAX_PATH];
	LPDIRECT3DDEVICE8		m_lpDevice;
	MESHTYPE				m_meshType;
	float					m_fPar1, m_fPar2, m_fPar3;
	UINT					m_uPar4, m_uPar5;
	// number of materials
	DWORD					m_dwNumMat;
	// arrays of textures and materials
	XTexture				*m_pTextures;
	D3DMATERIAL8			*m_pMaterials;

public:
	int						LoadMeshFromFile(LPCSTR szFileName, LPDIRECT3DDEVICE8	lpDevice, XResourceManager * pResMan);	
	int						CreateSphere(float fRadius, UINT uSlices, UINT uStacks, LPDIRECT3DDEVICE8	lpDevice);
	int						CreateBox(float fWidth, float fHeight, float fDepth, LPDIRECT3DDEVICE8	lpDevice);
	int						CreateCylinder(float fRadius1, float fRadius2, float fLenght, UINT uSlices, UINT uStacks, LPDIRECT3DDEVICE8	lpDevice);
	int						CreateTeapot(LPDIRECT3DDEVICE8	lpDevice);
	int						CreateTorus(float fInnerRadius, float fOuterRadius, UINT uSides, UINT uRings, LPDIRECT3DDEVICE8	lpDevice);
	int						Draw();
	int						Restore();
	void					Release();
	LPD3DXMESH				GetMesh()   { return m_lpMesh; }
	LPDIRECT3DDEVICE8		GetDevice() { return m_lpDevice; }
	BOOL					IsVisible() { return m_bVisible; }
	void					Visible(BOOL bVis = TRUE) { m_bVisible = bVis; }

	void					Translate(float fX, float fY, float fZ);
	void					RotateX(float fAngle);
	void					RotateY(float fAngle);
	void					RotateZ(float fAngle);
	void					ScaleXYZ(float fFactor);
	void					ScaleX(float fFactor);
	void					ScaleY(float fFactor);
	void					ScaleZ(float fFactor);

public:
	XMesh(void);
	~XMesh(void);
};
