#include "StdAfx.h"

#define		DISPLAY_API	__declspec(dllexport)

#include "xtexture.h"
#include "xmesh.h"
#include "xvertexbuffer.h"
#include "xindexbuffer.h"
#include "xresourcemanager.h"

XResourceManager::XResourceManager(void)
{

}

XResourceManager::~XResourceManager(void)
{
	m_arTextures.clear();
}

int	XResourceManager::AddTexture(XTexture * pTextureToAdd)
{
	if(pTextureToAdd) {
		m_arTextures.push_back(pTextureToAdd);
		return 0;
	}
	return -1;
}

int	XResourceManager::AddMesh(XMesh * pMeshToAdd)
{
	if(pMeshToAdd) {
		m_arMeshes.push_back(pMeshToAdd);
		return 0;
	}
	return -1;
}

int	XResourceManager::AddIndexBuffer(XIndexBuffer * pBufferToAdd)
{
	if(pBufferToAdd) {
		m_arIB.push_back(pBufferToAdd);
		return 0;
	}
	return -1;
}

int	XResourceManager::AddVertexBuffer(XVertexBuffer * pBufferToAdd)
{
	if(pBufferToAdd) {
		m_arVB.push_back(pBufferToAdd);
		return 0;
	}
	return -1;
}


int	XResourceManager::ReleaseAll()
{
	// release textures
	for(int i = 0; i < (int)m_arTextures.size(); i++) {
		m_arTextures[i]->Release();		
	}
	for(i = 0; i < (int)m_arMeshes.size(); i++) {
		m_arMeshes[i]->Release();		
	}
	for(i = 0; i < (int)m_arVB.size(); i++) {
		m_arVB[i]->Release();		
	}
	for(i = 0; i < (int)m_arIB.size(); i++) {
		m_arIB[i]->Release();		
	}
	return 0;
}


int	XResourceManager::RestoreAll()
{
	// restore textures
	for(int i = 0; i < (int)m_arTextures.size(); i++) {
		m_arTextures[i]->Restore();		
	}
	for(i = 0; i < (int)m_arMeshes.size(); i++) {
		m_arMeshes[i]->Restore();		
	}
	for(i = 0; i < (int)m_arVB.size(); i++) {
		m_arVB[i]->Restore();		
	}
	for(i = 0; i < (int)m_arIB.size(); i++) {
		m_arIB[i]->Restore();		
	}
	return 0;
}

	