#include "StdAfx.h"

#define		DISPLAY_API	__declspec(dllexport)

#include "../Common/Common.h"

#include "xVertexbuffer.h"

XVertexBuffer::XVertexBuffer(void)
{
	m_lpDevice = NULL;
	m_pVertexBuffer = NULL;
}

XVertexBuffer::~XVertexBuffer(void)
{
	Release();
	m_lpDevice = NULL;
}

int		XVertexBuffer::Create(UINT uiLength, DWORD dwUsage, DWORD dwFVF, D3DPOOL dwPool, LPDIRECT3DDEVICE8	lpDevice)
{	
	if(!lpDevice) 
	{
		XException exp("CreateVertexBuffer: Device is invalid.");
		THROW(exp);			
	}
	if(!m_pVertexBuffer) 
	{
		m_lpDevice = lpDevice;
		m_uiLength = uiLength;
		m_dwUsage = dwUsage;
		m_dwFVF = dwFVF;
		m_dwPool = dwPool;

		DWORD dwRet = m_lpDevice->CreateVertexBuffer(uiLength, dwUsage, dwFVF, dwPool, &m_pVertexBuffer);
		if(dwRet != S_OK) {
			XException exp("Cannot create vertex buffer.", dwRet);
			THROW(exp);							
		}
		return 0;
	}
	return -1;
}

int		XVertexBuffer::Restore()
{
	if(m_lpDevice && !m_pVertexBuffer)
	{
		DWORD dwRet = m_lpDevice->CreateVertexBuffer(m_uiLength, m_dwUsage, m_dwFVF, m_dwPool, &m_pVertexBuffer);
		if(dwRet != S_OK) {
			XException exp("Cannot create vertex buffer.", dwRet);
			THROW(exp);				
		}
		return 0;
	}
	return -1;
}

void	XVertexBuffer::Release()
{
	SAFE_RELEASE(m_pVertexBuffer);
}