// Input1.h: interface for the CInput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_)
#define AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DIRECTINPUT_VERSION 0x800
// Tento hlavickovy soubor je uzivatelsky pridany
#include <dinput.h>

#define KEYDOWN(name, key) (name[key] & 0x80)

#define		MOUSEBUTTON_LEFT					0
#define		MOUSEBUTTON_RIGHT					1

#ifndef INPUT_API
     #define INPUT_API __declspec( dllimport )
#endif // INPUT_API

#define		_S_CURSOR		_T("arrow.tga")

#include "Cursor.h"

class INPUT_API XInput  
{
	LPDIRECTINPUT8	m_lpDI;
	LPDIRECTINPUTDEVICE8	m_lpDIDKeyboard;
	// Mouse
	LPDIRECTINPUTDEVICE8	m_lpDIDMouse;

	BOOL	m_bInit;
	BOOL	m_bButtonDown;
	//
	// Rozliseni obrazovky
	D3DXVECTOR2	m_csResolution; 
	//
	// Souradnice kurzoru
	D3DXVECTOR2	m_ptCursor;

	//
	// Pole pro klavesnici + handling
	BYTE	m_arKeyboard[256]; 
	BOOL	m_IsHandled[256]; 

	//
	// Stavova struktura pro mys + handling (2 tl.)
	DIMOUSESTATE	m_MouseState;
	BOOL			m_bIsMouseHandled[2];

	//
	// Cursor
	CCursor			m_theCursor;
	BOOL			m_bShowCursor;
	
public:
	// Common func.
	HRESULT Init(HINSTANCE hInst, HWND hWnd, D3DXVECTOR2* csResolution, LPDIRECT3DDEVICE8 lpDevice);
	HRESULT	ProcessInput();
	//
	// Cursor function
	HRESULT UpdateCursor();
	void	ShowCursor(BOOL bShow = TRUE) {m_bShowCursor = bShow;}
	D3DXVECTOR2*	GetCursor() {return &m_ptCursor;}
	//
	// Detection
	BOOL	IsRButtonDown(BOOL _Handling = TRUE);
	BOOL	IsLButtonDown(BOOL _Handling = TRUE);
	BOOL	IsRButtonUp();
	BOOL	IsLButtonUp();
	BOOL	IsKeyDown(int Key, BOOL bHandle = TRUE);	

	HRESULT RestoreDevices();
	

public:
	XInput();
	virtual ~XInput();

private:	
	void	MoveCursor(int dx, int dy) {m_ptCursor.x += dx; m_ptCursor.y += dy;}	
	void	Clean();
};

#endif // !defined(AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_)
