#pragma once
#include "afxwin.h"

struct	FilteringData {

	D3DTEXTUREFILTERTYPE		MagFilterType;
	D3DTEXTUREFILTERTYPE		MinFilterType;
	D3DTEXTUREFILTERTYPE		MipFilterType;
};

struct	DisplayData {

	DWORD						AdapterOrdinal;
	D3DDEVTYPE					DeviceType;
	D3DDISPLAYMODE				DisplayMode;
	D3DMULTISAMPLE_TYPE			MultisampleType;

	FilteringData				Filtering;
	D3DFORMAT					TextureFormat;
	DWORD						dwBehavior;

	BOOL						bWindowed;
	BOOL						bFPSCounter;
	BOOL						bVSync;
	BOOL						bWireframe;
	int							iFPSLimit;
};

class CDisplaySetup : public CPropertyPage
{
	DECLARE_DYNAMIC(CDisplaySetup)

	// Direct3D variables
	IDirect3D8	*			m_lpD3DObject;
	D3DCAPS8				m_DeviceCaps;
			
	DisplayData				m_CurrentDisplaySettings;

public:
	CDisplaySetup();
	virtual ~CDisplaySetup();

// Dialog Data
	enum { IDD = IDD_DISPLAY };

	void	GetAdapters();
	void	GetDisplayModes();
	void	GetTextureFormats();
	void	GetDeviceCaps();
	void	GetTextureFilter();
	void	GetFSAA();

	void	DestroyModesList();
	
	void	LoadSettings();
	void	SaveSettings();

	void	UpdateDialog(BOOL bSaveAndValidate);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CComboBox m_ctrlAdapterList;
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnCbnSelchangeAdapter();
	CListBox m_ctrlDisplayModes;
	CStatic m_ctrlAdapterDesc;	
	
	BOOL m_bWindowedMode;
	BOOL m_bFPSCounter;
	BOOL m_bWireframe;
	int m_iDesiredFPS;
	BOOL m_bVSync;
	CComboBox m_ctrlTLSupport;
	CComboBox m_ctrlFSAAList;
	CComboBox m_ctrlTextureFormat;	
	afx_msg void OnLbnSelchangeResolutions();
	afx_msg void OnBnClickedTest();
	afx_msg void OnCbnSelchangeTexformat();
	afx_msg void OnCbnSelchangeTexfilter();
	afx_msg void OnCbnSelchangeTlsupport();
	afx_msg void OnCbnSelchangeFsaa();
	afx_msg void OnBnClickedWindowed();
	CComboBox m_ctrlTextureFilter;
};
