// SetupDlg.cpp : implementation file
//

#include	"stdafx.h"
#include	"Setup.h"

#include	"DisplaySetup.h"
#include	"AudioSetup.h"

#include	"SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSetupDlg dialog

CSetupDlg::CSetupDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSH_NOAPPLYNOW;    // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;  // Lose the Help button
	AddPage(&m_pageDisplaySetup);
	AddPage(&m_pageAudioSetup);
	m_hIcon = LoadIcon(NULL, MAKEINTRESOURCE(IDR_MAINFRAME));
}

CSetupDlg::CSetupDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSH_NOAPPLYNOW;    // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;  // Lose the Help button
	AddPage(&m_pageDisplaySetup);
	AddPage(&m_pageAudioSetup);
	m_hIcon = LoadIcon(NULL, MAKEINTRESOURCE(IDR_MAINFRAME));
}


BEGIN_MESSAGE_MAP(CSetupDlg, CPropertySheet)	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CSetupDlg message handlers

BOOL CSetupDlg::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	HWND hwnd = NULL;
	hwnd = ::GetDlgItem(GetSafeHwnd(), IDOK);
	if(hwnd) 
	{
		::SetWindowText(hwnd, "Save && Exit");
	}
	hwnd = ::GetDlgItem(GetSafeHwnd(), IDCANCEL);
	if(hwnd)
	{	
		::SetWindowText(hwnd, "Exit");		
	}
	
	
	return bResult;  // return TRUE  unless you set the focus to a control
}
